/*
   Use this file to test your implementation
   of FilterRectanglesBySize.java.

   Your output should agree with the file
   TestFilterRectanglesBySize.output.txt.
*/
import java.util.*;
import java.util.Comparator;
import java.awt.geom.*;

public class TestFilterRectanglesBySize
{
   public static void main(String[] args)
   {
      ArrayList<Rectangle2D.Double> r2d = new ArrayList<Rectangle2D.Double>();
      r2d.add( new Rectangle2D.Double(7.0, 5.0, 4.0, 1.0) );
      r2d.add( new Rectangle2D.Double(7.0, 5.0, 4.0, 2.0) );
      r2d.add( new Rectangle2D.Double(7.0, 5.0, 3.0, 1.0) );
      r2d.add( new Rectangle2D.Double(7.0, 5.0, 6.0, 1.0) );
      r2d.add( new Rectangle2D.Double(7.0, 3.0, 1.0, 1.0) );
      r2d.add( new Rectangle2D.Double(7.0, 7.0, 2.0, 2.0) );
      r2d.add( new Rectangle2D.Double(5.0, 4.0, 3.0, 2.0) );
      r2d.add( new Rectangle2D.Double(9.0, 1.0, 1.0, 1.0) );
      r2d.add( new Rectangle2D.Double(1.0, 1.0, 1.0, 1.0) );
      r2d.add( new Rectangle2D.Double(9.0, 9.0, 9.0, 9.0) );

     Filter<Rectangle2D.Double> filter = new FilterRectanglesBySize(
                                             new Rectangle2D.Double(7.0, 3.0, 1.0, 1.0),
                                             new Rectangle2D.Double(7.0, 7.0, 2.0, 2.0) );

      ArrayList<Rectangle2D.Double> r2d_filtered = new ArrayList<Rectangle2D.Double>();

      for (Rectangle2D.Double r : r2d)
         if ( filter.accept(r) )
         {
            r2d_filtered.add( r );
         }

      // Print the filtered ArrayList.
      for (Rectangle2D.Double r : r2d_filtered)
        System.out.println( r );
      System.out.println(); // blank line

      // Sort the filtered ArrayList.
      Comparator<Rectangle2D.Double> comp = new RectangleComparator();

      Collections.sort(r2d_filtered, comp);

      // Now the filtered ArrayList is sorted.
      for (Rectangle2D.Double r : r2d_filtered)
        System.out.println( r );
   }
}